#!/usr/bin/env python
# -*- coding: utf-8  -*-
# Script en Python que verifica si los tipos de rutas
# que hay en cada fichero implicado:
#      - Fichero absolutas.txt - Rutas absolutas
#      - Fichero relativas.txt - Rutas relativas
#      - Fichero simples.txt - Ficheros simples
 
# USO CORRECTO: python rutas.py [-h]
#   * -h o --help -> ayuda
 
# Creado por Noelia Sales Montes

# This program is free software: you can redistribute
# it and/or modify it under the terms of the GNU General
# Public License as published by the Free Software
# Foundation, either version 3 of the License, or any
# later version.

# This program is distributed in the hope that it will
# be useful, but WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

# You should have received a copy of the GNU General 
# Public License along with this program.  If not, see
# <http://www.gnu.org/licenses/>.

# Contacto:  
#            noelia.salesmontes@gmail.com 
 
import sys
#import os
#import shutil
import getopt
#import glob
import re

def usage():
    print "USO CORRECTO: python rutas.py [-h]"

def leerFich(f):
    lista = []
    fich = open(f,"r")
    while True:
        linea = fich.readline().split('\n')[0]
        if not linea: break
        else: lista.append(linea)
    fich.close()
    return lista

def procesar(fich, er):
    try:
        print "\n%s\nFichero %s\n" % ("-"*50, fich)
        elems = leerFich(fich)
        for e in elems:
            if er.search(e):
                print "%s cumple el patrón" % e
            else:
                print "%s no cumple el patrón" % e                
    except:
        print "ERROR %s" % fich
        sys.exit(1)

def compruebaRutas():
    reg_abs = re.compile(r"/([\w\.]/)*")
    reg_rel = re.compile(r"([\w\.])+/([\w\.]/)*")
    #reg_sim = re.compile(r"[\w\.[^/]]+")
    reg_sim = re.compile(r"[a-zA-Z_0-9\.]+")
    # Leemos los ficheros
    procesar("absolutas.txt", reg_abs)
    procesar("relativas.txt", reg_rel)
    procesar("simples.txt", reg_sim)

# Principal
if __name__ == "__main__":
    try:
        opts, args = getopt.getopt(sys.argv[1:], 'h',["help"])
    except getopt.GetoptError, err:
        # Imprimir error y ayuda y salir
        print str(err)
        usage()
        sys.exit(2)

    # Identificar opciones
    for o, a in opts:
        if o in ("-h", "--help"):
            usage()
        else:
            sys.exit(2)

    print "Ejecución final"
    compruebaRutas()
